#! Flux2D 12.0

from math import *
import os
import sys
import traceback


path = '../MESH'
if not os.path.exists(path):
    os.makedirs(path, mode=0777)

path = '../EXC_DATA'
if not os.path.exists(path):
    os.makedirs(path, mode=0777)

path = '../Synchro_E.txt'
if os.path.exists(path):
    os.remove(path)

newProject()
GeomMeshOptions[1].methodAutomaticMeshVolume=OptimizeDelaunayMeshInactivated()

openSketcher2dContext()

SketcherOption[1].magnetizationGrid=MagnetizationGrid(gridActivation='yes',
                                                      lengthGridCell=20.0,
                                                      cellSubdivision=10,
                                                      subdivisionPoint=10)

createGeometry(coordSystem=CoordSys['XY1'],
               idPoints=[1,2,3,4,5],
               coordinatesPoints=['0.0','65.0','0.0','25.0','65.0','0.0','25.0','45.0','0.0','35.0','35.0','0.0','35.0','0.0','0.0'],
               idLines=[1,2,3,4],
               typeLines=[1,1,1,1],
               pointsOfLines=[1,2,2,3,3,4,4,5])

createGeometry(coordSystem=CoordSys['XY1'],
               idPoints=[6],
               coordinatesPoints=['0.0','0.0','0.0'],
               idLines=[5,6],
               typeLines=[1,1],
               pointsOfLines=[1,6,6,5])

createGeometry(coordSystem=CoordSys['XY1'],
               idPoints=[7,8,9],
               coordinatesPoints=['0.0','55.04042474273162','0.0','-5.0','55.04042474273162','0.0','5.0','55.04042474273162','0.0'],
               idLines=[7,8],
               typeLines=[4,4],
               pointsOfLines=[8,9,7,9,8,7],
               radius=['5.000000','5.000000'],
               angle=['180.000000','180.000000'])

healAndSimplifyAllGeometry()

createGeometry(coordSystem=CoordSys['XY1'],
               idPoints=[8,9,12],
               coordinatesPoints=['0.0','35.11186204740119','0.0','-4.0','35.11186204740119','0.0','4.0','35.11186204740119','0.0'],
               idLines=[8,10],
               typeLines=[4,4],
               pointsOfLines=[9,12,8,12,9,8],
               radius=['4.000000','4.000000'],
               angle=['180.000000','180.000000'])

propagateGeometry(line=[Line[10],Line[8]],
               transformationType=2,
               coordSystem=CoordSys['XY1'],
               repetitionNumber=[2],
               repetitionValue=['12.5','0'],
               connectToOrigin=1)

healAndSimplifyAllGeometry()

propagateGeometry(line=[Line[6],Line[4],Line[3],Line[2],Line[1]],
               transformationType=1,
               transformationPoint=[Point[17],Point[6]],
               connectToOrigin=1)

propagateGeometry(line=[Line[18],Line[17],Line[16],Line[15]],
               transformationType=1,
               transformationPoint=[Point[17],Point[6]],
               connectToOrigin=1)

propagateGeometry(line=[Line[6]],
               transformationType=1,
               transformationPoint=[Point[17],Point[6]],
               connectToOrigin=1)

healAndSimplifyAllGeometry()

propagateGeometry(line=[Line[31],Line[30],Line[29],Line[28],Line[27],Line[26],Line[25],Line[24],Line[22],Line[21],Line[20],Line[19],Line[18],Line[17],Line[16],Line[15],Line[14],Line[13],Line[12],Line[11],Line[10],Line[9],Line[8],Line[7],Line[5],Line[4],Line[3],Line[2],Line[1]],
               transformationType=1,
               transformationPoint=[Point[6],Point[21]],
               connectToOrigin=1)

closeSketcher2dContext()

buildFaces()

AidedMesh[1].aidedMeshState=AidedMeshActivated(meshPoint=MeshPointAssigned(type=MeshPointDynamic()),
                                               meshDeviation=MeshDeviationAssignedExcludeIB(type=MeshDeviationExcludeIBRelative(value=0.8)),
                                               meshRelaxation=MeshRelaxation(lineMeshRelaxation=LineMeshRelaxationAssigned(type=LineMeshRelaxationLow()),
                                                                             faceMeshRelaxation=FaceMeshRelaxationAssigned(type=FaceMeshRelaxationLow())))


meshLines()

meshFaces()

saveProjectAs('../ELECTRIC/geomeshbuilt.FLU')

