#! Flux2D 18.0

from math import *
import os
import sys



Scenario(name='ReferenceValues')

Scenario['ReferenceValues'].adaptive = InactivatedAdaptive()

result = ExportDataRegionFace(exportDataFile=exportDexFluxFile(fileName='../MESH/MESH_EC_COND'),
                     mechanicalSetPosition=ReferencePosition(),
                     formula='dLossV',
                     regionFace=RegionFace['CONDUCTOR'],
                     lengthUnit=LengthUnit['MILLIMETER'],
                     coordSys=CoordSys['XY1'],
                     locationValues=LocationValuesNodes())

Scenario['REFERENCEVALUES'].openSessionMultiPhysics(projectName='../ELECTRIC/solved')

# Creation of a magnetic iteration synchronization file
# the thermal problem can continue the computation
f1=open('../Synchro_E.txt','a')
f1.close()     
print 'wait for response from thermal application'
# Waiting for the thermal iteration synchronization file
# to continue the magnetic computation
     
waitForFile(fileName="../Synchro_T.txt",existFile="exist")

MultipointSupportImportingCoordinates(multipointSupportName='COND_MULTI_TH',
                                      file=coordinatesImportDexFluxFile(coordinatesFileName='../MESH/MESH_TH_COND.DEX'),
                                      lengthUnit=LengthUnit['MILLIMETER'],
                                      mechanicalSetDependency=MultipointSupportWithoutMechanicalSet(),
                                      multipointSupportColor=Color['Green'],
                                      multipointSupportVisibility=Visibility['VISIBLE'],
                                      coordSys=CoordSys['XY1'])

lastInstance = SpatialFormulaMPSensor(name='multiphysicsSensor_Losses',
                       FormulaMPSensor='dLossV')

lastInstance = CosimExportMultipointSupport(name='EC_LOSSES',
                             lengthUnit=LengthUnit['MILLIMETER'],
                             coordSys=CoordSys['XY1'],
                             position=ReferencePosition(),
                             MPSensor=multiphysicsSensor['MULTIPHYSICSSENSOR_LOSSES'],
                             multipointSupport=MultipointSupport['COND_MULTI_TH'],
                             exportDataMultipointSupportRegion=ExportRegionFace(regionFace=RegionFace['CONDUCTOR']))

lastInstance = SpatialParameterTabulated(name='SQ_TEMP_CELSIUS',
                          parameterType=ScalarReal(),
                          defaultValue='20')

lastInstance = CosimImportDataRegSurf(name='TEMP_CELSIUS',
                       spatialParameter=SpatialParameter['SQ_TEMP_CELSIUS'],
                       position=ReferencePosition(),
                       lengthUnit=LengthUnit['MILLIMETER'],
                       coordSys=CoordSys['XY1'],
                       importMethod=NodeToNode(),
                       regionFace=RegionFace['CONDUCTOR'])

SpatialParameter['CU_RESISTIVITY'].SpatialFormula='1.7E-8*(1+0.00427*(SQ_TEMP_CELSIUS-20))'


lastInstance = FluxCosimulation(name='Cosimulation_EC_TT',
                 exchangeDirectory='../EXC_DATA',
                 outData=[CosimExportedData['EC_LOSSES']],
                 inData=[CosimImportedData['TEMP_CELSIUS']],
                 convergenceCriterion=ThirdPartEvalConvergence())

Scenario['REFERENCEVALUES'].closeSessionMultiPhysics()

Scenario['REFERENCEVALUES'].openSessionMultiPhysics(projectName='../ELECTRIC/solved')

solveCosimulation()

Scenario['REFERENCEVALUES'].closeSessionMultiPhysics()

saveProjectAs('../ELECTRIC/solved.FLU') 
     
	
