#! Flux2D 11.2

from math import *
import os
import sys
import traceback
import time 


lastInstance = IsovalueSpatialGroup(name='ISOVAL_TCelsius',
                     formula='tcelsius',
                     forceVisibility='yes',
                     smoothValues='yes',
                     group=[Groupspatial['1_DOMAIN']])
                     
selectCurrentStep(activeScenario=Scenario['THERMAL'],
                  parameterValue=['TIME=30.0'])

selectCurrentStep(activeScenario=Scenario['THERMAL'],
                  parameterValue=['TIME=100.0'])

IsovalueSpatialGroup['ISOVAL_TCELSIUS'].displayIsovalue()
            
PathStraightLine2PTS(name='Path_1',
                     pathDiscretization=IntervalPathDiscretization(intervalNumber=50),
                     regionFace='CONDUCTOR',
                     color=Color['White'],
                     visibility=Visibility['VISIBLE'],
                     startPoint=PathPoint(coordSys=CoordSys['XY1'],
                                          uvw=['-6', '65']),
                     endPoint=PathPoint(coordSys=CoordSys['XY1'],
                                        uvw=['-6', '-65']))


lastInstance = CompoundPath(name='CompoundPath_1',
                  paths=[Path['PATH_1']],
                  color=Color['Turquoise'],
                  visibility=Visibility['VISIBLE'])

cleanInvalidPaths()

SpatialCurve(name='TEMPERATURE',
                  compoundPath=CompoundPath['COMPOUNDPATH_1'],
                  formula=['Temp(Tkelvin)'])
time.sleep(60)
CurveSpatial2D['TEMPERATURE'].exportTXT(txtFile='../result/TestCase_RES',
               mode='add')

saveProjectAs('../THERMAL/postprocessed.FLU') 
