#! Flux2D 11.2

from math import *
import os
import sys


Scenario(name='THERMAL')

startMacroTransaction()

Scenario['THERMAL'].addPilot(pilot=MultiValues(parameter=VariationParameter['TIME'],
                                               intervals=[IntervalStepNumber(minValue=0.0,
                                                                             maxValue=100.0,
                                                                             stepNumber=21)]))

endMacroTransaction()

result = ExportNodeCoordinatesRegionFace(file=exportDexFluxFile(fileName='../MESH/MESH_TH_COND'),
                                mechanicalSetPosition=ReferencePosition(),
                                regionFace=RegionFace['CONDUCTOR'],
                                lengthUnit=LengthUnit['MILLIMETER'],
                                coordSys=CoordSys['XY1'])

lastInstance = SpatialParameterTabulated(name='SQ_dHeatV',
                          parameterType=ScalarReal(),
                          defaultValue='0')

RegionFace['CONDUCTOR'].thermalTransient2D=Thermal2DFaceThermalConductor(transparency='automatic',
                                                                                                                                                    material=Material['FLU_COPPER'],
                                                                                                                                                    heat=VolumeHeatSourceSpatialFormula(value='SQ_DHEATV'))

Scenario['THERMAL'].openSessionMultiPhysics(projectName='../THERMAL/solved')

f=open('../Synchro_T.txt','a')
f.close()

print 'Wait for response from Electric application'
#Waiting for the magnetic iteration synchronization file
#to can continue the thermal computation
waitForFile(fileName="../Synchro_E.txt",existFile="exist")
MultipointSupportImportingCoordinates(multipointSupportName='COND_MULTI_EC',
                                      file=coordinatesImportDexFluxFile(coordinatesFileName='../MESH/MESH_EC_COND.DEX'),
                                      lengthUnit=LengthUnit['MILLIMETER'],
                                      mechanicalSetDependency=MultipointSupportWithoutMechanicalSet(),
                                      multipointSupportColor=Color['Cyan'],
                                      multipointSupportVisibility=Visibility['VISIBLE'],
                                      coordSys=CoordSys['XY1'])

lastInstance = SpatialFormulaMPSensor(name='MULTIPHYSICSSENSOR_TCelsius',
                       FormulaMPSensor='TCelsius')

lastInstance = CosimExportMultipointSupport(name='TEMP_CELSIUS',
                             lengthUnit=LengthUnit['MILLIMETER'],
                             coordSys=CoordSys['XY1'],
                             position=ReferencePosition(),
                             MPSensor=multiphysicsSensor['MULTIPHYSICSSENSOR_TCELSIUS'],
                             multipointSupport=MultipointSupport['COND_MULTI_EC'],
                             exportDataMultipointSupportRegion=ExportRegionFace(regionFace=RegionFace['CONDUCTOR']))


CosimExportedData['TEMP_CELSIUS'].MPSensor=multiphysicsSensor['MULTIPHYSICSSENSOR_TCELSIUS']



lastInstance = CosimImportDataRegSurf(name='EC_LOSSES',
                       spatialParameter=SpatialParameter['SQ_DHEATV'],
                       position=ReferencePosition(),
                       lengthUnit=LengthUnit['MILLIMETER'],
                       coordSys=CoordSys['XY1'],
                       importMethod=NodeToNode(),
                       regionFace=RegionFace['CONDUCTOR'])

lastInstance = FluxCosimulation(name='Cosimulation_TT_EC',
                 transientComputationType=TransientType(exchangeFrequency=1),
                 exchangeDirectory='../EXC_DATA',
                 outData=[CosimExportedData['TEMP_CELSIUS']],
                 inData=[CosimImportedData['EC_LOSSES']],
                 convergenceCriterion=FluxEvalConvergence(threshold=5.0))

solveCosimulation()

Scenario['THERMAL'].closeSessionMultiPhysics()

saveProjectAs('../THERMAL/solved.FLU') 
     
